<?php
namespace Bar\Foobar\Controller;


/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2014
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * FoobarbazzaController
 */
class FoobarbazzaController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

	/**
	 * action list
	 *
	 * @return void
	 */
	public function listAction() {
		$foobarbazzas = $this->foobarbazzaRepository->findAll();
		$this->view->assign('foobarbazzas', $foobarbazzas);
	}

	/**
	 * action show
	 *
	 * @param \Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza
	 * @return void
	 */
	public function showAction(\Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza) {
		$this->view->assign('foobarbazza', $foobarbazza);
	}

	/**
	 * action new
	 *
	 * @param \Bar\Foobar\Domain\Model\Foobarbazza $newFoobarbazza
	 * @ignorevalidation $newFoobarbazza
	 * @return void
	 */
	public function newAction(\Bar\Foobar\Domain\Model\Foobarbazza $newFoobarbazza = NULL) {
		$this->view->assign('newFoobarbazza', $newFoobarbazza);
	}

	/**
	 * action create
	 *
	 * @param \Bar\Foobar\Domain\Model\Foobarbazza $newFoobarbazza
	 * @return void
	 */
	public function createAction(\Bar\Foobar\Domain\Model\Foobarbazza $newFoobarbazza) {
		$this->addFlashMessage('The object was created. Please be aware that this action is publicly accessible unless you implement an access check. See <a href="http://wiki.typo3.org/T3Doc/Extension_Builder/Using_the_Extension_Builder#1._Model_the_domain" target="_blank">Wiki</a>', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::ERROR);
		$this->foobarbazzaRepository->add($newFoobarbazza);
		$this->redirect('list');
	}

	/**
	 * action edit
	 *
	 * @param \Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza
	 * @ignorevalidation $foobarbazza
	 * @return void
	 */
	public function editAction(\Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza) {
		$this->view->assign('foobarbazza', $foobarbazza);
	}

	/**
	 * action update
	 *
	 * @param \Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza
	 * @return void
	 */
	public function updateAction(\Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza) {
		$this->addFlashMessage('The object was updated. Please be aware that this action is publicly accessible unless you implement an access check. See <a href="http://wiki.typo3.org/T3Doc/Extension_Builder/Using_the_Extension_Builder#1._Model_the_domain" target="_blank">Wiki</a>', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::ERROR);
		$this->foobarbazzaRepository->update($foobarbazza);
		$this->redirect('list');
	}

	/**
	 * action delete
	 *
	 * @param \Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza
	 * @return void
	 */
	public function deleteAction(\Bar\Foobar\Domain\Model\Foobarbazza $foobarbazza) {
		$this->addFlashMessage('The object was deleted. Please be aware that this action is publicly accessible unless you implement an access check. See <a href="http://wiki.typo3.org/T3Doc/Extension_Builder/Using_the_Extension_Builder#1._Model_the_domain" target="_blank">Wiki</a>', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::ERROR);
		$this->foobarbazzaRepository->remove($foobarbazza);
		$this->redirect('list');
	}

}