<?php
namespace Bar\Foobar\Tests\Unit\Controller;
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Test case for class Bar\Foobar\Controller\FoobarbazzaController.
 *
 */
class FoobarbazzaControllerTest extends \TYPO3\CMS\Core\Tests\UnitTestCase {

	/**
	 * @var \Bar\Foobar\Controller\FoobarbazzaController
	 */
	protected $subject = NULL;

	protected function setUp() {
		$this->subject = $this->getMock('Bar\\Foobar\\Controller\\FoobarbazzaController', array('redirect', 'forward', 'addFlashMessage'), array(), '', FALSE);
	}

	protected function tearDown() {
		unset($this->subject);
	}

	/**
	 * @test
	 */
	public function listActionFetchesAllFoobarbazzasFromRepositoryAndAssignsThemToView() {

		$allFoobarbazzas = $this->getMock('TYPO3\\CMS\\Extbase\\Persistence\\ObjectStorage', array(), array(), '', FALSE);

		$foobarbazzaRepository = $this->getMock('', array('findAll'), array(), '', FALSE);
		$foobarbazzaRepository->expects($this->once())->method('findAll')->will($this->returnValue($allFoobarbazzas));
		$this->inject($this->subject, 'foobarbazzaRepository', $foobarbazzaRepository);

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$view->expects($this->once())->method('assign')->with('foobarbazzas', $allFoobarbazzas);
		$this->inject($this->subject, 'view', $view);

		$this->subject->listAction();
	}

	/**
	 * @test
	 */
	public function showActionAssignsTheGivenFoobarbazzaToView() {
		$foobarbazza = new \Bar\Foobar\Domain\Model\Foobarbazza();

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$this->inject($this->subject, 'view', $view);
		$view->expects($this->once())->method('assign')->with('foobarbazza', $foobarbazza);

		$this->subject->showAction($foobarbazza);
	}

	/**
	 * @test
	 */
	public function newActionAssignsTheGivenFoobarbazzaToView() {
		$foobarbazza = new \Bar\Foobar\Domain\Model\Foobarbazza();

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$view->expects($this->once())->method('assign')->with('newFoobarbazza', $foobarbazza);
		$this->inject($this->subject, 'view', $view);

		$this->subject->newAction($foobarbazza);
	}

	/**
	 * @test
	 */
	public function createActionAddsTheGivenFoobarbazzaToFoobarbazzaRepository() {
		$foobarbazza = new \Bar\Foobar\Domain\Model\Foobarbazza();

		$foobarbazzaRepository = $this->getMock('', array('add'), array(), '', FALSE);
		$foobarbazzaRepository->expects($this->once())->method('add')->with($foobarbazza);
		$this->inject($this->subject, 'foobarbazzaRepository', $foobarbazzaRepository);

		$this->subject->createAction($foobarbazza);
	}

	/**
	 * @test
	 */
	public function editActionAssignsTheGivenFoobarbazzaToView() {
		$foobarbazza = new \Bar\Foobar\Domain\Model\Foobarbazza();

		$view = $this->getMock('TYPO3\\CMS\\Extbase\\Mvc\\View\\ViewInterface');
		$this->inject($this->subject, 'view', $view);
		$view->expects($this->once())->method('assign')->with('foobarbazza', $foobarbazza);

		$this->subject->editAction($foobarbazza);
	}

	/**
	 * @test
	 */
	public function updateActionUpdatesTheGivenFoobarbazzaInFoobarbazzaRepository() {
		$foobarbazza = new \Bar\Foobar\Domain\Model\Foobarbazza();

		$foobarbazzaRepository = $this->getMock('', array('update'), array(), '', FALSE);
		$foobarbazzaRepository->expects($this->once())->method('update')->with($foobarbazza);
		$this->inject($this->subject, 'foobarbazzaRepository', $foobarbazzaRepository);

		$this->subject->updateAction($foobarbazza);
	}

	/**
	 * @test
	 */
	public function deleteActionRemovesTheGivenFoobarbazzaFromFoobarbazzaRepository() {
		$foobarbazza = new \Bar\Foobar\Domain\Model\Foobarbazza();

		$foobarbazzaRepository = $this->getMock('', array('remove'), array(), '', FALSE);
		$foobarbazzaRepository->expects($this->once())->method('remove')->with($foobarbazza);
		$this->inject($this->subject, 'foobarbazzaRepository', $foobarbazzaRepository);

		$this->subject->deleteAction($foobarbazza);
	}
}
